SystemOrganization addCategory: #'Parasol-Tests'!

BPWebDriverTestCase subclass: #BPMiscTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPMiscTestCase methodsFor: 'misc.' stamp: 'KrisGybels 8/3/2012 12:36'!
componentClass

	^ BPTestComponent ! !

!BPMiscTestCase methodsFor: 'testing' stamp: 'KrisGybels 8/3/2012 13:13'!
testFileUpload

	| fileupload filesubmit file |
	
	(file := FileDirectory default fileNamed: 'Test.data')
		nextPutAll: 'Hello World!!';
		close.

	[
		fileupload := driver findElementByXPath: ('//input[@type=''file'']').
		filesubmit := driver findElementByID: 'sendFile'.
		fileupload sendKeys: file fullName.
		filesubmit click.
	
		self assert: (testComponent receivedFile contentsDecodedUsing: 'UTF-8') = 'Hello World!!'.
	] ensure: [ FileDirectory default deleteFileNamed: 'Test.data' ].
! !

BPWebDriverTestCase subclass: #BPRemoteWebDriverTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPRemoteWebDriverTestCase class methodsFor: 'accessing' stamp: 'KrisGybels 5/22/2012 10:09'!
packageNamesUnderTest

	^ #('NextPlan-SeleniumTests-Common')! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:21'!
componentClass

	^ BPTestComponent ! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:22'!
testClose

	self shouldnt: [ driver close ] raise: BPUnknownServerException.
	self waitForDriverToFinishClosing.
	self should: [ driver close ] raise: BPUnknownServerException.

! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 4/13/2012 09:48'!
testExecuteWith

	| inputField |
	self assert: (driver executeScript: '' with: #()) isNil.
	self assert: (driver executeScript: 'return 42' with: #()) = 42.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(0)) = 0.
	self assert: (driver executeScript: 'return arguments[arguments[0]]' with: #(1 42)) = 42.
	
	inputField := driver findElementByID: 'inputField'.
	self assert: (driver executeScript: 'return arguments[0].getAttribute(''type'')' with: (Array with: inputField)) = 'text'.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 7/4/2012 10:00'!
testFindElementByCSSSelector

	| exceptionThrown |
	self assert: (driver findElementByCSSSelector: '#testDiv2 :nth-child(3)') = (driver findElementByID: 'testDiv2p3').
	exceptionThrown := false.
	"There seems to be an inconsistency between different versions of Selenium and/or different browsers, so two different exceptions might be thrown:"
	[[ driver findElementByCSSSelector: '#testDiv2 :nth-ch' ]
		on: BPInvalidSelectorException
		do: [ :ex | exceptionThrown := true. ]]
		on: BPUnknownServerException
		do: [ :ex | exceptionThrown := true. ].
	self assert: exceptionThrown.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByClassName

	self assert: (driver findElementByClassName: 'testclass') = (driver findElementByID: 'testParagraph').
	self should: [ driver findElementByClassName: 'inexistantclass' ] raise: BPNoSuchElementException.
	
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByID

	self shouldnt: [ driver findElementByID: 'inputField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByID: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByLinkText

	self assert: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByLinkText: 'A Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByLinkText: 'Link' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByName

	self shouldnt: [ driver findElementByName: 'secretField' ] raise: BPNoSuchElementException.
	self should: [ driver findElementByName: 'elementThatDoesNotExist' ] raise: BPNoSuchElementException.
	self flag: 'Expand this test to check what happens when there are multiple elements with the same name.'.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByPartialLinkText

	self assert: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor1').
	self deny: (driver findElementByPartialLinkText: 'Link') = (driver findElementByID: 'anchor2').
	
	self should: [ driver findElementByPartialLinkText: 'Lxnk' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:19'!
testFindElementByTagName

	self assert: (driver findElementByTagName: 'input') = (driver findElementByID: 'inputField').
	self should: [ driver findElementByTagName: 'tagThatIsNeverUsed' ] raise: BPNoSuchElementException.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:18'!
testFindElementByXPath

	self assert: (driver findElementByXPath: '//div[@id=''testDiv1'']') = (driver findElementByID: 'testDiv1').
	self assert: (driver findElementByXPath: '//div[@id=''testDiv2'']') = (driver findElementByID: 'testDiv2').
	self should: [ driver findElementByXPath: '//div[@id=' ] raise: BPInvalidSelectorException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'JohanBrichau 5/18/2012 17:11'!
testFindElementsByClassName

	self assert: (driver findElementsByClassName: 'testclass2') size = 2.
	
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:22'!
testGetPageSource

	self assert: (driver getPageSource includesSubString: 'Supercalifragilisticexpialidocious').
	driver close.
	self waitForDriverToFinishClosing.
	self should: [ driver getPageSource ] raise: BPUnknownServerException.! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 13:59'!
testGetScreenshotAsByteArray

	|  form screenshotByteArray |

	screenshotByteArray := driver getScreenshotAsByteArray.
	form := PNGReadWriter formFromStream: screenshotByteArray readStream.
	self assert: form width > 0.
	self assert: form height > 0.
! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:03'!
testGetWindowHandle

	self assert: (driver getWindowHandle) isEmpty not.	! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:04'!
testGetWindowHandles

	self assert: (driver getWindowHandles) = (Array with: driver getWindowHandle).! !

!BPRemoteWebDriverTestCase methodsFor: 'running' stamp: 'KrisGybels 5/23/2012 19:53'!
testSwitchTo

	| windowHandle1 windowHandle2 |

	windowHandle1 := driver getWindowHandle.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles = (Array with: windowHandle1).

	(driver findElementByPartialLinkText: 'Wikipedia') click.
	self assert: driver getWindowHandle = windowHandle1.
	self assert: driver getTitle = 'Seaside'.
	self assert: driver getWindowHandles size = 2.

	windowHandle2 := (driver getWindowHandles copyWithout: windowHandle1) first.
	driver switchTo window: windowHandle2.
	self assert: driver getWindowHandle = windowHandle2.
	self assert: (driver getTitle beginsWith: 'Wikipedia').
! !

!BPRemoteWebDriverTestCase methodsFor: 'misc' stamp: 'KrisGybels 4/10/2012 16:03'!
waitForDriverToFinishClosing

	self flag: 'Check whether there is a better way to do this rather than just waiting for a set amount of time'.
	(Delay forSeconds: 1) wait.! !

BPWebDriverTestCase subclass: #BPWebElementTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPWebElementTestCase class methodsFor: 'accessing' stamp: 'KrisGybels 5/22/2012 10:09'!
packageNamesUnderTest

	^ #('NextPlan-SeleniumTests-Common')! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:21'!
componentClass

	^ BPTestComponent ! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:18'!
testClear

	| inputField submitButton secretField |
	inputField := driver findElementByID: 'inputField'.
	submitButton := driver findElementByID: 'submitButton'.

	inputField sendKeys: 'XYZ'.
	inputField clear.
	inputField sendKeys: 'ABC'.
	inputField sendKeys: 'DEF'.
	submitButton click.
	self assert: testComponent inputFieldValue = 'ABCDEF'.

	self should: [ inputField clear ] raise: BPStaleElementReferenceException.

	driver get: self baseURL asString.
	secretField := driver findElementByName: 'secretField'.
	self should: [ secretField clear ] raise: BPElementNotVisibleException.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/12/2012 11:06'!
testEquals

	| testDiv1 testDiv1p testDiv1pByID testDiv1pByClassName testDiv2 |
	
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.
	testDiv1pByID := driver findElementByID: 'testDiv1p'.
	testDiv1pByClassName := testDiv1 findElementByClassName: 'c1'.

	self flag: 'testDiv1pByID and testDiv1pByClassName do seem to have the same elementID; would be nice to expand this test with a case where the two elementIDs are not the same while still referring to the same element.'.
	self assert: testDiv1pByID = testDiv1pByClassName.
	self deny: testDiv1 = testDiv2.
	
	driver get: self baseURL asString.
	self flag: 'Should this not throw a stale element reference exception??'.
	self assert: testDiv1pByID = testDiv1pByClassName.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:20'!
testFindElementByClassName

	| testDiv1 testDiv2 testDiv1p testDiv2p1 testDiv2p2 testDiv2p3 |
	testDiv1 := driver findElementByID: 'testDiv1'.
	testDiv2 := driver findElementByID: 'testDiv2'.

	testDiv1p := driver findElementByID: 'testDiv1p'.
	testDiv2p1 := driver findElementByID: 'testDiv2p1'.
	testDiv2p2 := driver findElementByID: 'testDiv2p2'.
	testDiv2p3 := driver findElementByID: 'testDiv2p3'.
	
	self assert: (testDiv1p getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p1 getAttribute: 'class') = 'c2'.
	self assert: (testDiv2p2 getAttribute: 'class') = 'c1'.
	self assert: (testDiv2p3 getAttribute: 'class') = 'c1'.
	
	self assert: ((testDiv1 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv1p'.
	self assert: ((testDiv2 findElementByClassName: 'c1') getAttribute: 'id') = 'testDiv2p2'.
	self assert: ((testDiv2 findElementByClassName: 'c2') getAttribute: 'id') = 'testDiv2p1'.
	
	self should: [ testDiv1 findElementByClassName: 'unusedClassName' ] raise: BPNoSuchElementException.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/15/2012 16:19'!
testFindElementByTagName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/18/2012 13:56'!
testFindElementsByClassName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/18/2012 11:10'!
testFindElementsByTagName

	self flag: 'Write this test'.! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:46'!
testGetAttribute

	| inputField |
	inputField := driver findElementByID: 'inputField'.
	self assert: (inputField getAttribute: 'type') = 'text'.
	self assert: (inputField getAttribute: 'id') = 'inputField'.
	self assert: (inputField getAttribute: 'attributeThatIsNotSpecified') isNil.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:04'!
testGetLocation

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getLocation) =  (300@400).
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:04'!
testGetSize

	| imageElement |
	imageElement := driver findElementByID: 'image'.
	self assert: (imageElement getSize) = (80@50).
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/15/2012 16:05'!
testGetText

	| paragraphElement |
	paragraphElement := driver findElementByTagName: 'p'.
	self assert: paragraphElement getText = 'Supercalifragilisticexpialidocious'.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 4/11/2012 14:45'!
testIsDisplayed

	| inputField secretField |
	inputField := driver findElementByID: 'inputField'.
	secretField := driver findElementByName: 'secretField'.
	self assert: inputField isDisplayed.
	self deny: secretField isDisplayed.
! !

!BPWebElementTestCase methodsFor: 'running' stamp: 'KrisGybels 6/29/2012 15:21'!
testSendKeys

	| inputElement submitButton |
	self assert: testComponent inputFieldValue isNil.
	inputElement := driver findElementByID: 'inputField'.
	inputElement sendKeys: 'XYZ'.
	submitButton := driver findElementByID: 'submitButton'.
	submitButton click.
	self assert: testComponent inputFieldValue = 'XYZ'.

	driver get: self baseURL asString.
	self assert: testComponent inputFieldValue isNil.
	self should: [ inputElement sendKeys: 'XYZ' ] raise: BPStaleElementReferenceException.
! !

WAComponent subclass: #BPTestComponent
	instanceVariableNames: 'inputFieldValue receivedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Tests'!

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 4/11/2012 14:50'!
inputFieldValue

	^ inputFieldValue! !

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 8/3/2012 12:34'!
receiveFile: file

	! !

!BPTestComponent methodsFor: 'accessing' stamp: 'KrisGybels 8/3/2012 13:02'!
receivedFile

	^ receivedFile! !

!BPTestComponent methodsFor: 'rendering' stamp: 'KrisGybels 8/3/2012 13:02'!
renderContentOn: html

	html paragraph: 'Supercalifragilisticexpialidocious'.
	html form get; with: [
		html textInput id: 'inputField'; callback: [ :newValue | inputFieldValue := newValue ].
		html textInput name: 'secretField'; type: 'hidden'.
		html submitButton id: 'submitButton'.
	].
	html image id: 'image'; style: 'position:absolute;left:300px;top:400px'; form: (RectangleMorph new bounds: ((0@0) corner: (80@50)); yourself).
	html div id: 'testDiv1'; with: [
		html paragraph id: 'testDiv1p'; class: 'c1'.
	].
	html div id: 'testDiv2'; with: [
		html paragraph id: 'testDiv2p1'; class: 'c2'.
		html paragraph id: 'testDiv2p2'; class: 'c1'.
		html paragraph id: 'testDiv2p3'; class: 'c1'.
	].
	html anchor id: 'anchor1'; with: 'A Link'.
	html anchor id: 'anchor2'; with: 'A Link'.
	html paragraph
		id: 'testParagraph';
		class: 'testclass';
		with: 'Bla bla'.
	html div
		class: 'testclass2';
		with: ''.
	html anchor
		class: 'testclass2';
		with: 'foobar'.
	html anchor
		url: 'http://en.wikipedia.org/wiki/Main_Page';
		target: '_blank';
		with: 'Wikipedia'.
	html form multipart; with: [
		html fileUpload callback: [ :value | receivedFile := value ].
		html submitButton id: 'sendFile'; with: 'Send File'
	].

! !
